<?php
/**
 * Plugin Name: Olivery
 * Description: Integrate WooCommerce with Olivery.
 * Plugin URI:  https://website.olivery.app/?page_id=975
 * Version:     5.22
 * Author:      Olivery
 * Author URI:  http://website.olivery.app

 */
 if ( is_admin() ){

function olivery_init_session_f() {
    if ( ! session_id() ) {
        session_start();
    }
	if(!isset($_SESSION['sendToOlivaryBtn']))$_SESSION['sendToOlivaryBtn']='0';
}
// Start session on init hook.
function sanitize_text_field_allowHTML( $input ) {
	
     return $input ;/*$validated_input*/;

 }
 
add_action( 'admin_init', 'register_my_setting' );
function register_my_setting() {
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' => 'olivery_bs',
            );
	register_setting( 'header_group', 'olivery_login', $args1 ); 
	
	
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' => '12345678',
            );
	register_setting( 'header_group', 'olivery_password', $args1 ); 
	
	
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' => 'demo',
            );
	register_setting( 'header_group', 'olivery_db', $args1 ); 
	
	
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' => '1',
            );
	register_setting( 'header_group', 'olivery_customer_area', $args1 ); 
	
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' => '0111223222',
            );
	register_setting( 'header_group', 'olivery_company_sequence', $args1 ); 
	
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' => 'Quds',
            );
	register_setting( 'header_group', 'olivery_follower_address', $args1 ); 
	
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' => 'Ramallah',
            );
	register_setting( 'header_group', 'olivery_follower_area', $args1 ); 
	
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' =>get_bloginfo( 'name' ),
            );
	register_setting( 'header_group', 'olivery_follower_store_name', $args1 ); 
	
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' => '0569894922',
            );
	register_setting( 'header_group', 'olivery_follower_mobile_number', $args1 ); 
	
	$args1 = array(
            'type' => 'string', 
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
            'default' => '0569894922',
            );
	register_setting( 'header_group', 'olivery_follower_second_mobile_number', $args1 );
	
	


	register_setting(
        'header_group',
        'olivery_delivery_coms',
        array(
            'type' => 'array',
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
			 'default'=>array('demo','demo1','demo2'),
        )
    );
    
    
    register_setting(
        'header_group',
        'olivery_new_orders_statuses',
        array(
            'type' => 'array',
            'sanitize_callback' => 'sanitize_text_field_allowHTML',
			 'default'=>array( 'Olivery Completed','Olivery Processing','Olivery Returned'),
        )
    );
			
}

add_action( 'init', 'olivery_init_session_f' );


 add_action('admin_menu', 'olivery_plugin_setup_menu');
 
function olivery_plugin_setup_menu(){
    add_menu_page( 'Olivery', 'Olivery', 'manage_options', 'olivery', 'olivery_welcome_f' );	
    add_submenu_page( 'olivery', 'Olivery Settings', 'Olivery Settings',    'manage_options', 'olivery-settings','test_init');	
   
}
 
function olivery_welcome_f(){	if ( !current_user_can( 'manage_options' ) )  {		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );	}			 echo "<h1>Welcome to Olivery</h1>";	 echo "<p>Olivery is a platform that connect thousand of stores and delivery companies togather</p>";	 	 echo "<nr><br><h2>What is this plugin</h2>";	 echo "<p>This plugin allow you to integrate Olivery with your store that use WooCommerce </p>";	 echo "<p>Once you install and activate Olivery Plugin you will be able to send orders directly to Olivery , you will also have the abilty to let Olivery update you order status </p>";	 	}
 
function olivery_wc_key_f(){	if ( !current_user_can( 'manage_options' ) )  {		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );	}			 echo "<h1>Olivery Woccomerce Key </h1>";	 echo "<p>You Can Create this key from Woocommerce Settings -> advanced ->REST API<br><a target='_blank' href='https://docs.woocommerce.com/document/woocommerce-rest-api/'>More Information are here</a></p>";	 	 echo "<nr><br><h2>Why You Need This Key </h2>";	 echo "<p>Olivery  need  this key In order to  access your orders (set them as 'completed') </p>";	 	  echo "<nr><br><h2>How it works</h2>";	 echo "<p> When you send an order to Olivery , the order information  will contain  this key , then after Olivery proccess your order it will set it as completed using WooCommerce REST API </p>";	 	 	  echo "<nr><br><h2>Important Notes</h2>";	 echo "<p> assign this key to a user with 'Shop Manager' Role Level <br> Keep this key secured  and safe,  <br>Any one have this key will be able to access your store with 'Shop Manager' Role Level permissions</p>";}
 
function test_init(){
	
	if ( !current_user_can( 'manage_options' ) )  {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}
	  echo "<h1>Olivery integration Settings </h1>";
	echo '
	<form method="post" action="options.php"> 
	
	';
	
	settings_fields( 'header_group' );
	
	do_settings_sections( 'header_group' );
	
	/*settings_fields( 'general_setting' );*/
	
	/*do_settings_sections( 'general_setting' );*/
	
	
  
echo "<table class='options-table'>";
echo "<tr><th>olivery_login</th><td><input name='olivery_login' value='".esc_attr(get_option('olivery_login'))."'></td></tr>";
echo "<tr><th>olivery_password</th><td><input name='olivery_password' value='".esc_attr(get_option('olivery_password'))."'></td></tr>";
echo "<tr><th>olivery_db</th><td><input name='olivery_db' value='".esc_attr(get_option('olivery_db'))."'></td></tr>";
echo "<tr><th>customer_area</th><td><input name='olivery_customer_area' value='".esc_attr(get_option('olivery_customer_area'))."'></td></tr>";

echo "<tr><th>company_sequence</th><td><input name='olivery_company_sequence' value='".esc_attr(get_option('olivery_company_sequence'))."'></td></tr>";

echo "<tr><th>follower_address</th><td><input name='olivery_follower_address' value='".esc_attr(get_option('olivery_follower_address'))."'></td></tr>";

echo "<tr><th>follower_area</th><td><input name='olivery_follower_area' value='".esc_attr(get_option('olivery_follower_area'))."'></td></tr>";

echo "<tr><th>follower_store_name</th><td><input name='olivery_follower_store_name' value='".esc_attr(get_option('olivery_follower_store_name'))."'></td></tr>";

echo "<tr><th>follower_mobile_number</th><td><input name='olivery_follower_mobile_number' value='".esc_attr(get_option('olivery_follower_mobile_number'))."'></td></tr>";

echo "<tr><th>follower_second_mobile_number</th><td><input name='olivery_follower_second_mobile_number' value='".esc_attr(get_option('olivery_follower_second_mobile_number'))."'></td></tr>";

echo "<tr><th colspan=2 class='tit'><hr></th></tr>";
echo "<tr><th colspan=2 class='tit'>Delivery Companies</th></tr>";echo "<tr><th>Company Subdomain</th><th>Uncheck then click 'Save Changes' to Remove</th></tr>";
$arr_olivery_delivery_coms=get_option('olivery_delivery_coms');
for($ix=0;$ix<count($arr_olivery_delivery_coms);$ix++){
echo "<tr><th>".$arr_olivery_delivery_coms[$ix].":</th><td><input checked type='checkbox' name='olivery_delivery_coms[]' value='".$arr_olivery_delivery_coms[$ix]."'></td></tr>";
}
echo "<tr><th colspan=2 class='tit'><a style='cursor:pointer;' onclick='addNewDelvCom_f()'>New Delivery Company +</a></th></tr>";
echo "</table>";


echo "<br><table class='options-table-statuses'>";

echo "<tr><th colspan=2 class='tit'><hr></th></tr>";

echo "<tr><th colspan=2 class='tit'>Olivary Orders Statuse </th></tr>";
$new_order_statuses_arr=get_option('olivery_new_orders_statuses');
for($ix=0;$ix<count($new_order_statuses_arr);$ix++){
echo "<tr><td colspan=2><input  type='text' name='olivery_new_orders_statuses[]' value='".$new_order_statuses_arr[$ix]."' readonly></td></tr>";
}
echo "<tr><th colspan=2 class='tit'><a style='cursor:pointer;' onclick='addNewOrderStatus_f();' class='tit'>+ New Order Status</a></th></tr>";

echo "</table>";


submit_button(); 
echo "</form>
<style>
.submit:hover {
    background-color: transparent !important;
}
table.options-table th,table.options-table-statuses th{
	text-align:left;
}
table.options-table th.tit,table.options-table-statuses th.tit{
font-size:16px;

}
table.options-table,table.options-table-statuses{
min-width:480px;
}
</style>
<script>
function addNewDelvCom_f(){
console.log('addNewDelvCom_f');
element = document.querySelector('table.options-table');
var elN_ = document.createElement('tr');
elN_.innerHTML = \"<th>company sub domain:</th><td><input   name='olivery_delivery_coms[]' value=''></td>\";
element.append(elN_);
}

function addNewOrderStatus_f(){
console.log('addNewOrderStatus_f');
element = document.querySelector('table.options-table-statuses');
var elN_ = document.createElement('tr');
elN_.innerHTML = \"<th>Order Status:</th><td><input   name='olivery_new_orders_statuses[]' value=''></td>\";
element.append(elN_);
}
</script>
";
}



function send_to_olivery_f($dom_domain,$the_order){
$url="https://".$dom_domain.".olivery.app/create_order";
		$response = wp_remote_post($url, array(
    'headers'     => array('Content-Type' => 'application/json',
  'Cookie' => 'session_id=6d9a8377691fca5ae7a80cf690296842b43bfa77'),
    'body'        => '{
 "jsonrpc": "2.0", 
"params": { 
     "login":"'.esc_attr(get_option('olivery_login')).'",
      "password": "'.esc_attr(get_option('olivery_password')).'",
      "db":"'.esc_attr(get_option('olivery_db')).'",
      "customer_address": "'.$the_order->get_address().'",
      "customer_mobile": "'.$the_order->get_billing_phone().'",
      "customer_name": "'.$the_order->get_formatted_billing_full_name().' ['.$the_order->get_formatted_shipping_full_name().']",
      "customer_area": "'.esc_attr(get_option('olivery_customer_area')).'",
       "company_sequence":"'.esc_attr(get_option('olivery_company_sequence')).'",
      "cost":'.$the_order->get_total().',
      "follower_address":"'.esc_attr(get_option('olivery_follower_address')).'",
       "follower_area":"'.esc_attr(get_option('olivery_follower_area')).'",
       "follower_store_name":"'.esc_attr(get_option('olivery_follower_store_name')).'",
       "follower_ref_id":"'.$the_order->get_id().'",
        "follower_mobile_number":"'.esc_attr(get_option('olivery_follower_mobile_number')).'",
        "reference_id":"'.$the_order->get_id().'",
          "is_wordpress_order":"true",
       "follower_second_mobile_number":"'.esc_attr(get_option('olivery_follower_second_mobile_number')).'"
        		}
}',
    'method'      => 'POST',
    'data_format' => 'body',
));
return $response;


}//send_to_olivery_f



function woocommerce_admin_order_data_after_order_details_f( $the_order ) { 
   

 
   echo "<div style='float: left;margin-top: 40px;'>
	";
	
	/** btn  **/ 

	
	$current_uri = home_url( add_query_arg(  array(
    'sendToOlivary' => $the_order->get_id()
) ) );
	$current_uri = remove_query_arg('subdomain',$current_uri);
	$arr_olivery_delivery_coms=get_option('olivery_delivery_coms');
	$selectHTML="<option disabled selected value> -- select company  -- </option>";

for($ix=0;$ix<count($arr_olivery_delivery_coms);$ix++){
$selectHTML.= '<option  value="'.$arr_olivery_delivery_coms[$ix].'">'.$arr_olivery_delivery_coms[$ix].'</option>';

}
  echo '
  <a  class="button-primary"  onclick="document.getElementById(\'modal-urls\').style.display=\'table-cell\'">
 Send this order to Olivary</a>
  
  <div id="modal-urls" style="display:none;height: 100vh;position: fixed;width: 100vw;z-index: 99999;text-align: center;vertical-align: middle;left: 0;top: 0;background-color: #282828ee;padding-top: 100px;">
  <div class="modal-content">
  <h3 style="padding:12px;">Choose the delivery company  </h3>
  <select style="width:100%" onchange="document.getElementById(\'submit_to_olivery\').href+=\'&subdomain=\'+this.value" id="com-urls">'.$selectHTML.'</select>
  <br> <br>
  <a  class="button-primary modalBtn" id="submit_to_olivery" href="'.$current_uri.'" onclick="this.style.pointerEvents =\'none\';this.style.backgroundColor=\'#333\';this.innerHTML=\'Sending...\';">
 Send </a>

  <a  class="button modalBtn" onclick="document.getElementById(\'modal-urls\').style.display=\'none\';">
 Cancel </a>

 </div></div>
 <style>
 .modalBtn{
 width:49%;
 }
 .modal-content{
	 width:350px;
	 height:230px;
	 
	 
	 background: #fff;
    border: 1px solid #c3c4c7;
 
    box-shadow: 0 1px 1px rgb(0 0 0 / 4%);
    margin: auto;
    padding: 23px;
	 }
 
 </style>
 ';
 /*alert(document.getElementById(\'com-urls\').value);alert(this.href);*/

	/** end  btn  **/ 
	
		/*** request **/
	if(isset($_REQUEST['sendToOlivary']))
	{
			
			
			$canSend=true;/* this is only to be easy on the api for testing */
		if($canSend){
		$response=send_to_olivery_f($_REQUEST['subdomain'],$the_order);
		
		$olivery_success=0;
		$olivery_fail=0;
		$olivery_error=0;
			$fail_msg="undefined";
		if ( is_wp_error( $response ) ) {
    
	$olivery_error++;
	} else {
   
	$res_Success=json_decode($response['body']);
			$res_Success=$res_Success->result;
			$res_Success=$res_Success->Success;
		if($res_Success===true)$olivery_success++;
		else{
			$olivery_fail++;
		
			try{
			$fail_msg=json_decode($response['body'])->error->data->message;
			}catch(Exception  $exep_fail_msg){}
		}
}


/**/
		
		if($res_Success>0)printf('<div  class="notice notice-success is-dismissable"><p>' . __('Order has been  successfully sent to Olivery :'.$_REQUEST['subdomain'].' .', 'txtdomain') . '</p></div>');
		
		
		if($olivery_fail>0){
			printf('<div  class="notice  notice-error is-dismissable"><p>' . __('Order  failed to be sent to Olivery :'.$_REQUEST['subdomain'].' ,<br> error message:'.$fail_msg.'.', 'txtdomain') . '</p></div>');
			/*echo "<pre>";
			print_r($response);
			echo "</pre>";*/
		}
		
		
		if($olivery_error>0){
		    
		   if ( is_wp_error( $response ) ) {
		       $error_message = $response->get_error_message();
		       //$error_message.=$error_message."__br__";
		   }
		    printf('<div  class="notice  notice-error is-dismissable"><p>' . __('Error when trying to  sent to '.$_REQUEST['subdomain'].'.olivery.app', 'txtdomain') . ':'.$error_message.'</p></div>');
		}
		
/**/
		} /*if can send*/
		
	}
	
		/*** end request **/
	
echo "</div>";


	
}; /* woocommerce_admin_order_data_after_order_details_f */

         
// add the action 
add_action( 'woocommerce_admin_order_data_after_order_details', 'woocommerce_admin_order_data_after_order_details_f', 999, 1 ); 


add_filter( 'plugin_action_links_olivery/olivery.php', 'olivery_settings_link' );
function olivery_settings_link( $links ) {
	// Build and escape the URL.
	$url = esc_url( add_query_arg(
		'page',
		'olivery',
		get_admin_url() . 'admin.php'
	) );
	// Create the link.
	$settings_link = "<a href='$url'>" . __( 'Settings' ) . '</a>';
	// Adds the link to the end of the array.
	array_push(
		$links,
		$settings_link
	);
	return $links;
}//end nc_settings_link()


}//if(is admin)
	
/* add fucntionality of bulk action */ 

/* add the action to menu **/



	
add_filter('bulk_actions-edit-shop_order', function($bulk_actions) {
	$arr_olivery_delivery_coms=get_option('olivery_delivery_coms');
	//$bulk_actions[''] = __('Send a copy to :', 'txtdomain');
	$oliveryActions=array();
	for($ix=0;$ix<count($arr_olivery_delivery_coms);$ix++){
		$oliveryActions['send-to-olivery-'.$arr_olivery_delivery_coms[$ix]]= __(''.$arr_olivery_delivery_coms[$ix].'.olivery.app', 'txtdomain');

}/* for loop	*/
	$bulk_actions['Send a copy to']=$oliveryActions;
	return $bulk_actions;
});//add_filter 'bulk_actions-edit-shop_order'



/* handle the action */
add_filter('handle_bulk_actions-edit-shop_order', function($redirect_url, $action, $post_ids) {
    
    
    
$redirect_url = remove_query_arg('olivery_error');
		$redirect_url = remove_query_arg('olivery_fail',$redirect_url);
		$redirect_url = remove_query_arg('olivery_success',$redirect_url);
	$redirect_url = remove_query_arg('sent-to-olivery-fail-message',$redirect_url);
	
	$arr_olivery_delivery_coms=get_option('olivery_delivery_coms');
	for($ix=0;$ix<count($arr_olivery_delivery_coms);$ix++){
	if ($action == 'send-to-olivery-'.$arr_olivery_delivery_coms[$ix]) {
	
		$faildMsgs="";
		$olivery_error=0;
		$olivery_fail=0;
		$olivery_success=0;		
		foreach ($post_ids as $post_id) {
			$order = wc_get_order( $post_id );
        $order_data = $order->get_data();
		$response=send_to_olivery_f($arr_olivery_delivery_coms[$ix],$order);
		
		
		
		if ( is_wp_error( $response ) ) {
			
		$error_message = $response->get_error_message();		$faildMsgs.=$error_message."__br__";
	
		$olivery_error++;
		} else {
			$res_Success=json_decode($response['body']);
			$res_Success=$res_Success->result;
			$res_Success=$res_Success->Success;
		if($res_Success===true)$olivery_success++;
		else{ 		$olivery_fail++;		try{	
		    $fail_msg="485:wp canot find error message";	
		$fail_msg=json_decode($response['body'])->error->data->message;			}catch(Exception  $exep_fail_msg){}		$faildMsgs.="order number [".$post_id."] failed, message:".$fail_msg."__br__";		}
		}
		}
		$redirect_url = add_query_arg('olivery_error', $olivery_error, $redirect_url);
		$redirect_url = add_query_arg('olivery_fail', $olivery_fail, $redirect_url);
		$redirect_url = add_query_arg('olivery_success', $olivery_success, $redirect_url);
		for($jx=0;$jx<count($arr_olivery_delivery_coms);$jx++){
		if($arr_olivery_delivery_coms[$jx]!=$arr_olivery_delivery_coms[$ix])
		$redirect_url = remove_query_arg( 'sent-to-olivery-'.$arr_olivery_delivery_coms[$ix],$redirect_url );
		}
		$redirect_url = add_query_arg('sent-to-olivery-'.$arr_olivery_delivery_coms[$ix], count($post_ids), $redirect_url);				$redirect_url = add_query_arg('sent-to-olivery-fail-message', $faildMsgs, $redirect_url);
	}
	}/* for loop */
	return $redirect_url;


}, 10, 3);/* add_filter 'handle_bulk_actions-edit-shop_order' */


/* show notice after the action */
add_action('admin_notices', function() {
	$failorErrorMessage="";
	if(isset($_REQUEST['sent-to-olivery-fail-message']))$failorErrorMessage="<br>".str_replace("__br__","<br>",$_REQUEST['sent-to-olivery-fail-message'])."<br>";
	$arr_olivery_delivery_coms=get_option('olivery_delivery_coms');
	for($ix=0;$ix<count($arr_olivery_delivery_coms);$ix++){
	if (!empty($_REQUEST['sent-to-olivery-'.$arr_olivery_delivery_coms[$ix]])) {
	
		$num_changed = (int) $_REQUEST['sent-to-olivery-'.$arr_olivery_delivery_coms[$ix]];
		printf('<div id="message" class="notice notice-info is-dismissable"><p>' . __('%d Orders submitted to Olivery App <br>Delivery Company prefex: '.$arr_olivery_delivery_coms[$ix].'.', 'txtdomain') . '</p></div>', $num_changed);
		
		$olivery_successCount = (int) $_REQUEST['olivery_success'];
		if($olivery_successCount>0)printf('<div  class="notice notice-success is-dismissable"><p>' . __('Olivery: %d Orders  successful .', 'txtdomain') . '</p></div>', $olivery_successCount);
		
		$olivery_failCount = (int) $_REQUEST['olivery_fail'];
		if($olivery_failCount>0)printf('<div  class="notice  notice-error is-dismissable"><p>' . __('Olivery: %d Orders  failed .', 'txtdomain') . $failorErrorMessage.'</p></div>', $olivery_failCount);
		
		$olivery_errorCount = (int) $_REQUEST['olivery_error'];
		if($olivery_errorCount>0)printf('<div  class="notice  notice-error is-dismissable"><p>' . __('Olivery: %d Orders have errors  .', 'txtdomain') . $failorErrorMessage. '</p></div>', $olivery_errorCount);
		
		
	}
	}/* for loop*/
}); /* add_action 'admin_notices' */


/* end add fucntionality of bulk action */ 

/*updated on 14-10-2021*/
/*updated on 17-10-2021*/
/*updated on 18-10-2021*/
/*updated on 19-10-2021*/
/*updated on 21-10-2021*/
/*updated on 23-10-2021*/
/*updated on 24-10-2021*/
/*updated on 01-12-2021*/
 ?>
